import 'package:example/employee/employee.controller.dart';
import 'package:flutter/material.dart';
import 'package:tecfy_basic_package/tecfy_basic_package.dart';

class EmployeeListPage extends TecfyStatefulWidget<EmployeeController> {
  EmployeeListPage({Key? key, EmployeeController? controller})
      : super(controller, key: key);

  @override
  _EmployeeListPageState createState() => _EmployeeListPageState();

  @override
  TecfyBeamerPageRoute? beamer() {
    return TecfyBeamerPageRoute('/employees',
        (p0, p1, p2) => BeamerService.beamPageEx(child: EmployeeListPage()));
  }
}

class _EmployeeListPageState
    extends TecfyState<EmployeeListPage, EmployeeController> {
  @override
  EmployeeController createController() => EmployeeController();

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('Employees')),
      floatingActionButton: FloatingActionButton(
        child: Text('Add Employee'),
        onPressed: controller.onOpenNewEmployeePage,
        isExtended: true,
      ),
      body: ListView.builder(
        itemCount: controller.employees.length,
        itemBuilder: (c, i) => ListTile(
          title: Text(controller.employees[i].displayName),
          trailing: Text(controller.employees[i].idValue),
        ),
      ),
    );
  }
}
