part of tecfy_basic_package;

abstract class TecfyStatefulWidget<C extends TecfyController>
    extends StatefulWidget {
  final C? controller;
  TecfyStatefulWidget(this.controller, {Key? key}) {
    if (beamer() != null && BeamerService.routes.containsKey(beamer()!.path)) {
      print('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
      print(
          'XXXXXX you need to register the beamer function in BeamerServer.pages');
      print('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
    }
  }

  TecfyBeamerPageRoute? beamer();
}

abstract class TecfyState<T extends TecfyStatefulWidget,
        C extends TecfyController> extends State<T>
    with LifecycleAware, LifecycleMixin {
  late C controller;

  /// Whether this [State] object is displayed on the screen.
  bool isDislplayed = false;
  Future<void> onDisplayed(Widget page, bool _isDislplayed) async {
    controller.onDisplayed(this.widget, _isDislplayed);
  }

  C createController();

  @override
  void onLifecycleEvent(LifecycleEvent event) {
    if (event == LifecycleEvent.active) {
      controller.state = this;
      isDislplayed = true;
    } else {
      isDislplayed = false;
    }
    onDisplayed(this.widget, isDislplayed);
  }

  @override
  initState() {
    controller = createController();
    print(this.widget.runtimeType);
    controller.init(this.widget);
    controller.initLate(this.widget).then((value) => controller.setState());
    super.initState();
  }

  @override
  dispose() {
    controller.dispose();
    super.dispose();
  }
}
